package com.dade.plugin_login;


import android.content.Intent;
import android.text.TextUtils;

import androidx.annotation.NonNull;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;

/** PluginLoginPlugin */
public class PluginLoginPlugin implements FlutterPlugin, MethodCallHandler , ActivityAware {
  private MethodChannel channel;
  private ActivityPluginBinding activityAware;
  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "plugin_login");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getPlatformVersion")) {
      Intent intent = new Intent();
      intent.setAction("com.appstore.manager.login.action");
      activityAware.getActivity().startActivityForResult(intent,1001);
      activityAware.addActivityResultListener(new PluginRegistry.ActivityResultListener() {
        @Override
        public boolean onActivityResult(int requestCode, int resultCode, Intent data) {
          if (requestCode == 1001){
            if (data == null || !data.hasExtra("user_phone_num")){
              result.success("软仓账号获取失败");
              return true;
            }
            String userName = data.getStringExtra("user_phone_num");
            if (TextUtils.isEmpty(userName)){
              result.success("软仓账号获取失败");
              return true;
            }
            result.success(userName);
          }
          return true;
        }
      });
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }

  @Override
  public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
    activityAware = binding;

  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {
    onDetachedFromActivity();
  }

  @Override
  public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {
    onAttachedToActivity(binding);
  }

  @Override
  public void onDetachedFromActivity() {
    activityAware = null;
  }
}
